#!/bin/sh
pen=300.00

# Bremen
name=revsca2
if test -f "$name.time"; then
    rm $name.time
fi

while read line
do
  bench=`echo $line | awk -F ' ' '{print $3}'`
  time=0
  mem=-1
  err=${bench}_verify.err
  toolog=${bench}_verify.toollog
  status=`awk '/status:/{print $NF}' $err`
  case x"$status" in
    xok)
       time=`awk '/real:/{printf "%.2f\n", $(NF -1)}' $err`
       mem=`awk '/space:/{printf "%.2f\n", $(NF -1)}' $err`
       string=`grep "correct" $toolog`;
       if [ -z "$string" ]
       then
        time=$pen
        mem=-1
       fi
      ;;
    *)
     time=$pen
       ;;
  esac


  echo $time >> $name.time
  echo $mem >> $name.mem

done < ../benchmarks
