#!/usr/bin/env python3
import sys
import matplotlib.pyplot as plt
import matplotlib
import matplotlib.cm as cm
matplotlib.rcParams['mathtext.fontset'] = 'stix'
matplotlib.rcParams['font.family'] = 'STIXGeneral'



names =  ["amulet2.1",  "amulet2.0",  "amulet1.5",          "amulet1.0",    "dyposub" ,     "revsca2",    "revsca", "abc"]
labels = ["AMulet 2.1","AMulet 2.0", "AMulet 1.5", "AMulet 1.0", "DyPoSub", "RevSCA-2.0", "RevSCA", "ABC-based"]
cols =   ["magenta",   "purple",     "blue",      "green",           "orange",     "brown",  "red", "gold"]
markers =["o",   "+",   "3", "^", "<", "p", "s", "X", "v"]
order= [1,2,3,4,5,6,7,8,9]
#line=[1,2,3,4,4]


ypoint = [0,1,2,3,4,5]

for i in range(len(names)):
   index = order[i]-1
   name = names[index]
   time_file_name = name+"/"+name+".mem"
   time_file= open(time_file_name, "r")
   times = time_file.read().split('\n')




   times  = [float(i)/1024 for i in times[:-1] if float(i)>-1]
   times = sorted(times)

   length=len(times)

   line,=plt.plot(times, ypoint[0:length], color=cols[index], marker = markers[index], fillstyle='none', label=labels[index])
   line.set_clip_on(False)


#plt.legend(loc='upper left', bbox_to_anchor=(1.05, 1))
plt.legend(loc='upper left', bbox_to_anchor=(-0.1115, 1.32), fontsize=14, ncol=3)
plt.axis([0.01, 100, 0, 4])
plt.ylabel("Input bit-width", fontsize=18)
plt.yticks([0,1,2,3,4], [128,256,512,1024,2048])
plt.xscale("log")
plt.xlabel("Maximum Memory Usage in GB", fontsize=16)
plt.tick_params(labelsize=16)
plt.grid()
plt.savefig("mem.pdf", bbox_inches = 'tight', pad_inches = 0.1)
