#!/bin/bash


pen=86400.00

# AMULET
name=amulet1.0
if test -f "$name.time"; then
    rm $name.time
fi


while read line
do
  bench=`echo $line | awk -F ' ' '{print $3}'`
  totaltime=0
  mem=-1
  err=${bench}_substitution.err
  status=`awk '/status:/{print $NF}' $err`
  case x"$status" in
    xok)
     times=`awk '/real:/{printf "%.2f\n", $(NF -1)}' $err`
       ;;
    *)
     totaltime=$pen
       ;;
   esac

  msg="UNSATISFIABLE"
  log=${bench}_verify_cnf.log
  err=${bench}_verify_cnf.err

  status=`awk '/status:/{print $NF}' $err`
  if [ "$status" != "ok" ]
  then
     totaltime=$pen
  else
    string=`grep $msg $log`;
    if [ -z "$string" ]
    then
       totaltime=$pen
    else
       timec=`awk '/real:/{printf "%.2f\n", $(NF -1)}' $err`
    fi
  fi


  log=${bench}_verify_aig.log
  err=${bench}_verify_aig.err

  status=`awk '/status:/{print $NF}' $err`
  if [ "$status" != "ok" ]
  then
     totaltime=$pen
  else
    string=`grep " CORRECT" $log`;
    if [ -z "$string" ]
    then
       totaltime=$pen
    else
       timea=`awk '/real:/{printf "%.2f\n", $(NF -1)}' $err`
       mem=`awk '/space:/{printf "%.2f\n", $(NF -1)}' $err`
    fi

  fi


  if [[ "$totaltime" == 0 ]]
  then
    totaltime=$(awk "BEGIN {print $times+$timec+$timea; exit}")
  fi


  echo $totaltime  >> $name.time
  echo $mem >> $name.mem

done < ../benchmarks
